#include "gpmain.h"
#include "dos/dos.h"

GPDRAWSURFACE gpDraw;
GPDIRENTRY MDL[4096];
ulong DIRCOUNT;

int frame = 0;
int count = 0;
void ProcTimer0(void);


void GpMain(void *arg)
{
	int i, cnt_surface;

#ifdef GP32
	GpClockSpeedChange(132000000, 0x24001, 2);
	//GpClockSpeedChange (80000000, 0x48012, 1);
	//GpClockSpeedChange (99000000, 0x3a002, 2);
#endif
	cnt_surface = GpGraphicModeSet(8, NULL);
	i = GpLcdSurfaceGet(&gpDraw, 0);
	GpRectFill(NULL, &gpDraw, 0, 0, gpDraw.buf_w, gpDraw.buf_h, 0xff);	//surface fill color in white
	
	GpSurfaceSet(&gpDraw);
	
	if ( !(GPC_LCD_ON_BIT & GpLcdStatusGet()) ) GpLcdEnable();

	GpFatInit();

	GpPcmInit(PCM_S44,PCM_16BIT);

#ifdef GP32
__asm {
    MRC p15, 0, R5, c1, c0, 0	// read control register
    BIC r5,r5,#2				// align control OFF
    MOV r6,0x1004
    ORR r5,r5,r6				// I/D cache ON
    MCR p15, 0, R5, c1, c0, 0	//write control register
}
#endif


	GpDirEnumList("gp:\\gpmm\\pcegp\\",0,1024,(GPDIRENTRY*)&MDL[0],&DIRCOUNT); // only call this once!!
	GpRelativePathSet("gp:\\gpmm\\pcegp\\");           

	textout((char*)"main_loop()");
	i = main_loop();
}


void textout(char* text)
{
	GpRectFill(NULL, &gpDraw, 0, 0, 320, 20, 0x00);
	GpTextOut(NULL, &gpDraw, 0, 0, (char*)text, 0xff);
	//GpThreadSleep(200);
}


void ProcTimer0(void)
{
	count++;

	if (count == 50)
	{
		char tmp_string[64];

		gp_str_func.sprintf(tmp_string, "%d", frame);

		GpRectFill(NULL, &gpDraw, 290, 20, 30, 20, 0x00);
		GpTextOut(NULL, &gpDraw, 290, 20, (char*)tmp_string, 0xff);

		count = 0;
		frame = 0;
	}
}
